Package: widgetTools
Title: Creates an interactive tcltk widget
Version: 1.89.0
Date: 2008-10-28
Author: Jianhua Zhang
Description: This packages contains tools to support the construction
        of tcltk widgets
Depends: R (>= 2.4.0), methods, utils, tcltk
Suggests: Biobase
biocViews: Infrastructure
LazyLoad: yes
Maintainer: Jianhua Zhang <jzhang@jimmy.harvard.edu>
License: LGPL
git_url: https://git.bioconductor.org/packages/widgetTools
git_branch: devel
git_last_commit: 0513252
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 23:36:50 UTC; biocbuild

# This function makes a viewer that shows the content of an object.
# A viewer is a list box with a scroll bar attached.

makeViewer <- function (target, vWidth = NULL, vHeight = NULL,
                        hScroll = FALSE, vScroll = TRUE,
                        what = "list", side = "left", text = ""){

    if(!is.null(vWidth)){
        if(vWidth <= 0){
            stop("Invalid width value!")
        }
    }else{
        if(!is.null(vHeight)){
            if(vWidth <= 0){
                stop("Invalid height value!")
            }
        }
    }

    aViewer <- .getViewer(target, vWidth, vHeight, what, text)

    if(vScroll){
        vScr <- tkscrollbar(target, orient = "vertical",
                    command = function(...) tkyview(aViewer,...))
        tkconfigure(aViewer,
                yscrollcommand = function(...) tkset(vScr, ...))
        tkpack(vScr, side = "right", fill = "y")
    }
    if(hScroll){
       hScr <- tkscrollbar(target, orient = "horizontal",
                    command = function(...) tkxview(aViewer,...))
       tkconfigure(aViewer,
                xscrollcommand = function(...) tkset(hScr, ...))
       tkpack(hScr, side = "bottom", fill = "x")
    }
    tkpack(aViewer, side = side, fill = "both", expand = TRUE)

    aViewer
}

.getViewer <- function(target, vWidth, vHeight, what, text){

    switch(tolower(what),
           "canvas" = aViewer <- tkcanvas(target),
           "text" = aViewer <- .doText(target, text = text),
           "list" = aViewer <- .doList(target, text = text),
           stop("Wrong viwer definition"))
    if(!is.null(vWidth)){
        tkconfigure(aViewer, width = vWidth)
    }
    if(!is.null(vHeight)){
        tkconfigure(aViewer, height = vHeight)
    }

   return(aViewer)
}

.doList <- function(target, text){
    temp <- tklistbox(target, font = "courier 11")
    writeList(temp, text, clear = TRUE)
    return(temp)
}

.doText <- function(target, text){
    temp <- tktext(target, wrap = "none", font = "courier 11")
    tkinsert(temp, "end", text)
    return(temp)
}

### R code from vignette source 'widgetTools.Rnw'

###################################################
### code chunk number 1: widgetTools.Rnw:111-113
###################################################
library(widgetTools)
PWEnv <- new.env(hash = TRUE, parent = parent.frame(1))


###################################################
### code chunk number 2: widgetTools.Rnw:170-192
###################################################
label1 <- label(wName = "label1", wValue = "File Name: ", wEnv = PWEnv)
entry1 <- entryBox(wName = "entry1", wValue = "Feed me using browse",
                   wEnv = PWEnv)
browse2Entry1 <- function(){
    tempValue <- tclvalue(tkgetOpenFile())
    temp <- get(wName(entry1), env = PWEnv)
    wValue(temp) <- paste(tempValue, sep = "", collapse = ";")
    assign(wName(entry1), temp, env = PWEnv)
}
button1 <- button(wName = "button1", wValue = "Browse",
                     wFuns = list(command = browse2Entry1), wEnv = PWEnv)
list1 <- listBox(wName = "list1", wValue = c(Option1 = TRUE, Option2 = FALSE,
                                 Option3 = FALSE), wEnv = PWEnv)
text1 <- textBox(wName = "text1", wValue = "Feed me something",
                 wEnv = PWEnv)
label2 <- label(wName = "label2", wValue = "Select one:  ", wEnv = PWEnv)
radios1 <- radioButton(wName = "radios1", wValue = c(radio1 = TRUE,
                       radio2 = FALSE, radio3 = FALSE), wEnv = PWEnv)
label3 <- label(wName = "label3", wValue = "Select one to many: ",
                wEnv = PWEnv)
checks1 <- checkButton(wName = "checks1", wValue = c(check1 = TRUE,
                       check22 = FALSE, check3 = FALSE), wEnv = PWEnv)


###################################################
### code chunk number 3: widgetTools.Rnw:232-236
###################################################
wName(label1)
wName(label1) <- "YYY"
wName(label1)
wName(label1) <- "label1"


###################################################
### code chunk number 4: widgetTools.Rnw:251-256
###################################################
pWidgets <- list(topRow = list(label1 = label1, entry1 = entry1,
                 button1 = button1), textRow = list(list1 = list1,
                 text1 = text1), radGroup = list(label2 = label2,
                 radios1 = radios1), chkGroup = list(label3 = label3,
                                     checks1 = checks1))


###################################################
### code chunk number 5: widgetTools.Rnw:303-308
###################################################
if(interactive()){
aWidget <- widget(wTitle = "A test widget", pWidgets, funs = list(),
                 preFun = function() print("Hello"),
                 postFun = function() print("Bye"), env = PWEnv)
}


###################################################
### code chunk number 6: widgetTools.Rnw:328-335
###################################################
if(interactive()){
wValue(pWidgets(aWidget)[["topRow"]][["entry1"]])
wValue(pWidgets(aWidget)[["textRow"]][["list1"]])
wValue(pWidgets(aWidget)[["textRow"]][["text1"]])
wValue(pWidgets(aWidget)[["radGroup"]][["radios1"]])
wValue(pWidgets(aWidget)[["chkGroup"]][["checks1"]])
}

# A wraper of the file function that checks to see if a given file
# name does exist.

safeFileOpen <- function(fileName) {

    if (file.exists(fileName)){
        info <- file.info(fileName)
        if(info$isdir){
            return(paste(fileName, "is a directory"))
        }
        if(file.access(fileName, mode = 4) != 0){
            return(paste("You don't have read permission to file", fileName))
        }
        if(regexpr("\\.rda$|\\.Rda$", fileName) > 0){
            if(readLines(fileName, n = 1) == "RDX2"){
                return(paste(fileName, "is a binary file"))
            }else{
                return(file(fileName))
            }
        }
        if(regexpr("\\.gz", fileName) > 0){
            return(gzfile(fileName))
        }else if(regexpr("\\.zip", fileName) > 0){
            return(unz(fileName))
        }else if(regexpr("\\.bz2", fileName) > 0 ){
            return(bzfile(fileName))
        }else{
            return(file(fileName))
        }
    }else
        return(paste(fileName,"doest not exist"))
}

.onLoad <- function(libname, pkgname, where) {
    require("methods", quietly=TRUE) || stop("Package methods not available")
    capable <- capabilities()
    if (!capable["tcltk"]) {
        stop("The tcltk package is not working.  Please consult the R FAQ")
    }
}

.onAttach <- function(libname, pkgname) {
    if (.Platform$OS.type == "windows")
      suppressWarnings(require("Biobase")) && addVigs2WinMenu("widgetTools")
}

dropdownList <- function(base, options, textvariable, width = 10,
                         default, editable = FALSE){

    upDateEntry <- function(){
        if(!editable){
            tkconfigure(entry, state = "normal")
        }
        options(show.error.messages = FALSE)
        opt <- try(getListOption(entry, options))
        options(show.error.messages = TRUE)
        if(!inherits(opt, "try-error")){
            writeList(entry, opt, clear = TRUE)
            if(!editable){
                tkconfigure(entry, state = "disabled")
            }
        }
    }

    if(!missing(default)){
        if(!is.element(default, options)){
            tkmessageBox(title = "Data error warning",
                         message = paste("The default value \"",
                         default, "\" is not an element of ",
                         "the options \"", paste(options, sep = "",
                                   collapse = ","), "\"", sep = ""),
                         icon = "warning", type = "ok")
        }
        tclvalue(textvariable) <- default
    }else{
        tclvalue(textvariable) <- options[1]
    }
    dropFrame <- tkframe(base, borderwidth = 2, relief = "sunken")
    entry <- tkentry(dropFrame, width = width, textvariable = textvariable,
                     borderwidth = 1)
    if(!editable){
        tkconfigure(entry, state = "disabled")
    }
    tkpack(entry, side = "left", expand = TRUE, fill = "both")
    dropBut <- tkbutton(dropFrame, width = 1, text = "v", font = "bold",
                        command = upDateEntry)
    tkpack(dropBut, side = "left", expand = FALSE)
    tkpack(dropFrame, expand = TRUE, fill = "x")

    return(invisible())
}

getListOption <- function(targetWidget, options, height, vScroll = FALSE){
    newEntry <- NULL
    end <- function(){
        newEntry <<- as.character(tclObj(selection))[as.integer(
                                                 tkcurselection(list)) + 1]
        tkgrab.release(base)
        tkdestroy(base)
    }
    if(missing(height)){
        height <- length(options)
    }
    selection <- tclVar()
    tclObj(selection) <- options
    tipX <- as.numeric(tkwinfo("rootx", targetWidget))
    tipY <- as.numeric(tkwinfo("rooty", targetWidget)) +
        as.numeric(tkwinfo("height", targetWidget))
    # Takes out the frame and title bar
    tkwm.overrideredirect(base <- tktoplevel(), TRUE)
    on.exit(tkdestroy(base))
    # Put the TW in the right place
    tkwm.geometry(base, paste("+", tipX, "+", tipY, sep = ""))
    list <- tklistbox(base, listvariable = selection, height = height,
                      width = max(unlist(sapply(options, nchar))))
    if(vScroll){
        vScr <- tkscrollbar(base, orient = "vertical",
                    command = function(...) tkyview(list,...))
        tkconfigure(list,
                yscrollcommand = function(...) tkset(vScr, ...))
        tkpack(vScr, side = "right", fill = "y")
    }
    tkbind(list, "<Double-Button-1>", end)
    tkpack(list, expand = FALSE)

    tkgrab.set(base)

    tkwait.window(base)

    return(newEntry)
}

# This functions provide common operations that may be performed on
# tcltk widgets.

writeText <- function(widget, value, clear = TRUE){
    if(is.list(value) || is.data.frame(value)){
        value <- capture.output(print(value))
    }
    if(clear){
        tkdelete(widget, "0.0", "end")
    }
    tkinsert(widget, "end", value)
}

writeList <- function(widget, value, clear = TRUE){
    if(is.list(value) || is.data.frame(value)){
        value <- capture.output(print(value))
    }
    if(clear){
        tkdelete(widget, 0, "end")
    }
    do.call(tkinsert, c(list(widget, "end"), as.list(value)))
}

getListValue <- function(which){
    listValue <- NULL
    index <- as.numeric(tkcurselection(which))
    for(i in index){
        listValue <- c(listValue, as.character(tkget(which, i)))
    }
    return(listValue)
}

getTextValue <- function(which){
    return(tclvalue(tkget(which, "0.0", "end")))
}

getEntryValue <- function(which){
    return(tclvalue(tkget(which)))
}

oneVScrList <- function (base, data){

    lists <- list()

    colNames <- colnames(data)
    sortData <- function(colNum){
        for(i in 1:length(lists)){
            if(i == colNum){
                writeList(lists[[i]], sort(data[,i]), clear = TRUE)
            }else{
                writeList(lists[[i]], data[match(sort(data[,colNum]),
                              data[,colNum]), i], clear = TRUE)
            }
        }
    }
    for (i in 1:length(colNames)) {
        tempFrame <- tkframe(base)
        tkpack(tkbutton(tempFrame, text = colNames[i],
                  width = nchar(colNames[i])), expand = FALSE, fill = "x")
        lists[[colNames[i]]] <- tklistbox(tempFrame, exportselection = FALSE,
                                     width = max(sapply(data[,i], nchar)))
        writeList(lists[[colNames[i]]], data[,i])
        tkpack(lists[[colNames[i]]], expand = TRUE, fill = "both")
        fun <- function() {}
        body <- list(as.name("{"),
                     substitute(sortData(j), list(j = i)))
        body(fun) <- as.call(body)
        tempBut <- tkbutton(tempFrame, text = "Sort", width = 5,
                            command = fun)
        tkpack(tempBut, expand = FALSE, fill = "x")
        tkpack(tempFrame, side = "left", expand = FALSE, fill = "y")
    }
    bindYView <- function(...){
        for(i in lists){
            tkyview(i,...)
        }
    }

    vScr <- tkscrollbar(base, orient = "vertical", command = bindYView)
    tkpack(vScr, side = "right", fill = "y")
    for (i in lists) {
        tkconfigure(i, yscrollcommand = function(...) tkset(vScr,
            ...))
    }
    return(lists)
}

# This group of functions are constructors of objects of the classes
# defined by init.R.


entryBox <- function(wName, wEnv, wValue = "", wWidth = 50, wHeight = 0,
                     wFuns = list(), wNotify = list(),
                     wPreFun = function (x) x,
                     wPostFun = function(x) x, wView = new("widgetView")){

    .nameGood(name = wName)
    new("basicPW", wName = wName, wType = "entry", wValue = wValue,
        wWidth = wWidth, wHeight = wHeight, wFuns = wFuns, wNotify = wNotify,
        wPreFun = wPreFun, wPostFun = wPostFun, wEnv = wEnv, wView = wView)
}

textBox <- function(wName, wEnv, wValue = "", wWidth = 25, wHeight = 12,
                    wFuns = list(), wNotify = list(),
                    wPreFun = function (x) x,
                    wPostFun = function(x) x, wView = new("widgetView")){

    .nameGood(name = wName)
    new("basicPW", wName = wName, wType = "text", wValue = wValue,
        wWidth = wWidth, wHeight = wHeight, wFuns = wFuns, wNotify = wNotify,
        wPreFun = wPreFun, wPostFun = wPostFun, wEnv = wEnv, wView = wView)
}

listBox <- function(wName, wEnv, wValue = "", wWidth = 25, wHeight = 10,
                    wFuns = list(), wNotify = list(),
                    wPreFun = function (x) x,
                    wPostFun = function(x) x, wView = new("widgetView")){

    .nameGood(name = wName)
    new("basicPW", wName = wName, wType = "list", wValue = wValue,
        wWidth = wWidth, wHeight = wHeight, wFuns = wFuns, wNotify = wNotify,
        wPreFun = wPreFun, wPostFun = wPostFun, wEnv = wEnv, wView = wView)
}

checkButton <- function(wName, wEnv, wValue, wWidth = 50,
                        wFuns = list(), wNotify = list(),
                        wPreFun = function (x) x,
                        wPostFun = function(x) x, wView = new("widgetView")){

    .nameGood(name = wName)
    new("basicPW", wName = wName, wType = "check", wValue = wValue,
        wWidth = wWidth, wFuns = wFuns, wNotify = wNotify,
        wPreFun = wPreFun, wPostFun = wPostFun, wEnv = wEnv, wView = wView)
}

radioButton <- function(wName, wEnv, wValue, wWidth = 50,
                        wFuns = list(), wNotify = list(),
                        wPreFun = function (x) x,
                        wPostFun = function(x) x, wView = new("widgetView")){

    .nameGood(name = wName)
    new("basicPW", wName = wName, wType = "radio", wValue = wValue,
        wWidth = wWidth, wFuns = wFuns, wNotify = wNotify,
        wPreFun = wPreFun, wPostFun = wPostFun, wEnv = wEnv, wView = wView)
}

label <- function(wName, wEnv, wValue = "", wWidth = 0, wHeight = 0,
                  wFuns = list(), wNotify = list(),
                  wPreFun = function (x) x,
                  wPostFun = function(x) x, wView = new("widgetView")){

    .nameGood(name = wName)
    new("basicPW", wName = wName, wType = "label", wValue = wValue,
        wWidth = wWidth, wHeight = wHeight, wFuns = wFuns, wNotify = wNotify,
        wPreFun = wPreFun, wPostFun = wPostFun, wEnv = wEnv, wView = wView)
}

button <- function(wName, wEnv, wValue = "", wWidth = 12, wHeight = 0,
                   wFuns = list(), wNotify = list(), wPreFun = function (x) x,
                   wPostFun = function(x) x, wView = new("widgetView") ){

    .nameGood(name = wName)
    new("basicPW", wName = wName, wType = "button", wValue = wValue,
        wWidth = wWidth, wHeight = wHeight, wFuns = wFuns, wNotify = wNotify,
        wPreFun = wPreFun, wPostFun = wPostFun, wEnv = wEnv, wView = wView)
}

.nameGood <- function(name){
    if(name == "" || is.null(name) || is.na(name)){
        stop("Invalid name!")
    }
}

widgetView <- function(WVTitle, vName, widgetids = list(),
                       theWidget = new("widget"), winid = NULL){
    if(is.null(winid)){
         winid <- ""
         class(winid) <- "tkwin"
    }
    temp <- new("widgetView", WVTitle = WVTitle, vName = vName,
                widgetids = widgetids, theWidget = theWidget, winid = winid)
    base <- tktoplevel()
    tktitle(base) <- WVTitle
    winid(temp) <- base
    return(temp)
}

# This function constructs a widget object with default values if not
# supplied.
# pWidgets - a list of lists with each element being a pWidget object;
# funs - a list of functions that will be associated with buttons on
# the interface of the tcltk widget to be created. The name of the
# function will be the text appears on the button and the function
# will be executed when the button is pressed;
# preFun - a function that will be executed when the tcltk widget is
# constructed;
# postFun - a function that will be executed when the tcltk widget is
# destroyed.

widget <- function(wTitle, pWidgets, funs = list(),
                   preFun = function() print("Hello"),
                   postFun = function() print("Bye"), env,
                   defaultNames = c("Finish", "Cancel")){
    # Execute the function that is supposed to run first
    preFun()
    # A variable to keep track of the status
    END <- FALSE
    # A local copy of pWidgets to work on
    localPWs <- pWidgets
    # Construct a widgetView object
    widgetView <- widgetView(WVTitle = wTitle, vName = "widget1")
    tkgrab.set(winid(widgetView))
    # Construct a widget object and assign it to widgetView
    temp <- new("widget", wTitle = wTitle, env = env)
    theWidget(widgetView) <- temp
    # A Clear, Cancel, and Finish are the default buttons
    cancelBut <- function(){
        tkgrab.release(winid(widgetView))
        killWin(widgetView)
    }
    finishBut <- function(){
        END <<-  TRUE
        killWin(widgetView)
    }
#    clearBut <- function(){
#        .putPW2Env(localPWs, widgetView)
#        renewView(widgetView, pWidgets)
#    }
    tcl("tk_focusFollowsMouse")
    finish <- button(wName = "finish", wValue = defaultNames[1], wWidth = 8,
                     wFuns = list(command = finishBut), wEnv = new.env())
    cancel <- button(wName = "cancel", wValue = defaultNames[2], wWidth = 8,
        wFuns = list(command = cancelBut), wEnv = new.env())
#    clear <- button(wName = "clear", wValue = "Clear", wWidth = 8,
#        wFuns = list(command = clearBut), wEnv = new.env())
    defaultFuns <- list(finish = finish, cancel = cancel)
    if(length(funs) > 0){
        for(i in names(wFuns)){
            temp <- button(wName = i, wValue = i, wWidth = 12,
                           wFuns = wFuns[[i]], wEnv = new.env())
            userFuns[[i]] <- temp
        }
        localPWs[["userFuns"]] <- userFuns
    }
    localPWs[["default"]] <- defaultFuns
    # Render the widgets using the local copy
    widgetids(widgetView) <- renderWidgets(widgetView, localPWs)
    # Keep a copy of pWidgets and the widgetView in a specified
    # environment
    .putPW2Env(localPWs, widgetView)

    winWait(widgetView)
    # Execute the function to be run at the end
    postFun()
    # Act accordingly based on either the Cancel or Finish botton was
    # clicked
    if(END){
        pWidgets(temp) <- .getChanges(pWidgets)
        return(temp)
    }else{
        #pWidgets(temp) <- pWidgets
        return(NULL)
    }
#    return(temp)
}
# Write the value of the primary widgets to the enviroment
.putPW2Env <- function(pWidgets, widgetView){
    putOne <- function(pWidget){
        if(!is.null(widgetView)){
            wView(pWidget) <- widgetView
        }
        assign(wName(pWidget), pWidget, env = wEnv(pWidget))
    }

    for(i in names(pWidgets)){
#        if(length(pWidgets[[i]]) > 1){
            lapply(pWidgets[[i]], putOne)
#        }else{
#            putOne(pWidgets[[i]])
#        }
    }
}
# Gets the values for each primary widget object stored in the
# environment and uses the values to update the values of the a list
# primary widgets passed as an argument.
.getChanges <- function(pWidgets){
    for(i in names(pWidgets)){
        if(length(pWidgets[[i]]) > 0){
            for(j in names(pWidgets[[i]])){
                pWidgets[[i]][[j]] <-
                    wEnv(pWidgets[[i]][[j]])[[wName(pWidgets[[i]][[j]])]]
            }
        }else{
            pWidgets[[i]] <- get(wName(pWidgets[[i]]),
                                            env = wEnv(pWidgets[[i]]))
        }
    }
    return(pWidgets)
}

# A function to mimic a tooltip using tcltk only
# text - the content of the tool tip
# targetWidget - the widget to which the tooltip is going to be associated
# width - the width of the tooltip measured as pisels.

tooltip <- function(text, targetWidget, width = 350){

    end <- function(){
        tkdestroy(base)
    }

    tipX <- as.numeric(tkwinfo("rootx", targetWidget)) +
            as.numeric(tkwinfo("width", targetWidget))
    tipY <- as.numeric(tkwinfo("rooty", targetWidget))

    # Takes out the frame and title bar
    tkwm.overrideredirect(base <- tktoplevel(), TRUE)
    on.exit(tkdestroy(base))
    # Put the TW in the right place
    tkwm.geometry(base, paste("+", tipX, "+", tipY, sep = ""))
    tip <- tklabel(base, text = text, background = "white",
                   wraplength = width)
    tkpack(tip)

    tkbind(targetWidget, "<Leave>", end)

    tkwait.window(base)

    return(invisible())
}

# This function initilizes the widget class and the associsted
# functions.
    setClass("widget", representation(wTitle = "character",
                                      pWidgets = "list",
                                      env = "environment",
                                      funs = "list",
                                      preFun = "function",
                                      postFun = "function"))
    # Set the get methods
    setGeneric("wTitle",
                   function(object) standardGeneric("wTitle"))
    setMethod("wTitle", "widget",
              function(object) object@wTitle)

    setGeneric("pWidgets",
                   function(object) standardGeneric("pWidgets"))
    setMethod("pWidgets", "widget",
              function(object) object@pWidgets)

    setGeneric("wEnv",
                   function(object) standardGeneric("wEnv"))
    setMethod("wEnv", "widget",
              function(object) object@env)

    setGeneric("funs",
                   function(object) standardGeneric("funs"))
    setMethod("funs", "widget",
              function(object) object@funs)

    setGeneric("preFun",
                   function(object) standardGeneric("preFun"))
    setMethod("preFun", "widget",
              function(object) object@preFun)

    setGeneric("postFun",
                   function(object) standardGeneric("postFun"))
    setMethod("postFun", "widget",
              function(object) object@postFun)

    setGeneric("wTitle<-", function(object, value)
                   standardGeneric("wTitle<-"))
    setReplaceMethod("wTitle", "widget", function(object, value){
                  object@wTitle <- value; object})

    setGeneric("pWidgets<-", function(object, value)
                   standardGeneric("pWidgets<-"))
    setReplaceMethod("pWidgets", "widget", function(object, value){
                  object@pWidgets <- value; object})

    setGeneric("env<-", function(object, value)
                   standardGeneric("env<-"))
    setReplaceMethod("env", "widget", function(object, value){
                  object@env <- value; object})

    setGeneric("funs<-", function(object, value)
                   standardGeneric("funs<-"))
    setReplaceMethod("funs", "widget", function(object, value){
                  object@funs <- value; object})

    setGeneric("preFuns<-", function(object, value)
                   standardGeneric("preFuns<-"))
    setReplaceMethod("preFuns", "widget", function(object, value){
                  object@preFuns <- value; object})

    setGeneric("postFuns<-", function(object, value)
                   standardGeneric("postFuns<-"))
    setReplaceMethod("postFuns", "widget", function(object, value){
                  object@postFuns <- value; object})

    # Set the interface methods
    setGeneric("updateRadio",
                   function(object, PWName, bName)
                   standardGeneric("updateRadio"))
    setMethod("updateRadio", "widget",
              function(object, PWName, bName) {
                  tempPW <- get(PWName, env = wEnv(object))
                  tempValue <- wValue(tempPW)
                  tempValue[1:length(tempValue)] <- FALSE
                  tempValue[bName] <- TRUE
                  wValue(tempPW) <- tempValue
                  assign(wName(tempPW), tempPW, env = wEnv(tempPW))
              })

    setGeneric("updateList",
                   function(object, PWName, opts)
                   standardGeneric("updateList"))
    setMethod("updateList", "widget",
              function(object, PWName, opts) {
                  tempPW <- get(PWName, env = wEnv(object))
                  tempValue <- wValue(tempPW)
                  tempValue[1:length(tempValue)] <- FALSE
                  tempValue[bName] <- TRUE
                  wValue(tempPW) <- tempValue
                  assign(wName(tempPW), tempPW, env = wEnv(tempPW))
              })

    setGeneric("updateCheck",
                   function(object, PWName, bName)
                   standardGeneric("updateCheck"))
    setMethod("updateCheck", "widget",
              function(object, PWName, bName) {
                  tempPW <- get(PWName, env = wEnv(object))
                  tempValue <- wValue(tempPW)
                  if(tempValue[bName]){
                      tempValue[bName] <- FALSE
                  }else{
                      tempValue[bName] <- TRUE
                  }
                  wValue(tempPW) <- tempValue
                  assign(wName(tempPW), tempPW, env = wEnv(tempPW))
              })

    setGeneric("updateText",
                   function(object, PWName, value)
                   standardGeneric("updateText"))
    setMethod("updateText", "widget",
              function(object, PWName, value) {
                  tempPW <- get(PWName, env = wEnv(object))
                  wValue(tempPW) <- value
                  assign(wName(tempPW), tempPW, env = wEnv(tempPW))
              })


# This function initilizes a win class with default functions
# title - a character string for the text to be displayed as the title
# of the widget to be created
# name - a character string for the name of window holding the widget
# elements;
# winid - a tkwin object holding the id for the window;
# widgetids - a list whose elements are the name and tkwin ids for the
# widget elements to be created.
#
setClass("widgetView", representation(WVTitle = "character",
                                      vName = "character",
                                      winid = "ANY",
                                      widgetids = "list",
                                      theWidget = "widget"))
## Set the get methods
setGeneric("vName",
           function(object) standardGeneric("vName"))
setMethod("vName", "widgetView",
          function(object) object@vName)

setGeneric("winid",
           function(object) standardGeneric("winid"))
setMethod("winid", "widgetView",
          function(object) object@winid)

setGeneric("WVTitle",
               function(object) standardGeneric("WVTitle"))
setMethod("WVTitle", "widgetView",
          function(object) object@WVTitle)

setGeneric("widgetids",
           function(object) standardGeneric("widgetids"))
setMethod("widgetids", "widgetView",
          function(object) object@widgetids)

setGeneric("theWidget",
           function(object) standardGeneric("theWidget"))
setMethod("theWidget", "widgetView",
          function(object) object@theWidget)

setGeneric("vName<-", function(object, value)
               standardGeneric("vName<-"))
setReplaceMethod("vName", "widgetView", function(object, value){
    object@vName <- value; object})

setGeneric("winid<-", function(object, value)
           standardGeneric("winid<-"))
setReplaceMethod("winid", "widgetView", function(object, value){
    object@winid <- value; object})

setGeneric("widgetids<-", function(object, value)
           standardGeneric("widgetids<-"))
setReplaceMethod("widgetids", "widgetView", function(object, value){
    object@widgetids <- value; object})

setGeneric("theWidget<-", function(object, value)
           standardGeneric("theWidget<-"))
setReplaceMethod("theWidget", "widgetView", function(object, value){
    object@theWidget <- value; object})

setGeneric("renderWidgets",
           function(widgetView, pWidgets)
           standardGeneric("renderWidgets"))
setMethod("renderWidgets", c("widgetView", "list"),
          function(widgetView, pWidgets)
          return(.doWidgets(widgetView, pWidgets)))

setGeneric("renewView",
           function(widgetView, pWidgets)
           standardGeneric("renewView"))
setMethod("renewView", c("widgetView", "list"),
          function(widgetView, pWidgets)
          .renew(widgetView, pWidgets))

setGeneric("updateDisplay",
           function(widgetView, PWName, PWType, value)
           standardGeneric("updateDisplay"))
setMethod("updateDisplay", "widgetView",
          function(widgetView, PWName, PWType, value){
              widgetids <- widgetids(widgetView)
              if(PWType == "entry"){
                  writeList(widgetids[[PWName]], value)
              }else{
                  if(PWType == "text"){
                      writeText(widgetids[[PWName]], value)
                  }
              }
          })

setGeneric("killWin",
           function(tkWidget) standardGeneric("killWin"))
setMethod("killWin", "widgetView",
          function(tkWidget) tkdestroy(winid(tkWidget)))

setGeneric("winWait",
           function(tkWidget) standardGeneric("winWait"))
setMethod("winWait", "widgetView",
          function(tkWidget) tkwait.window(winid(tkWidget)))


# This group of functions initialize all the classes needed for
# widgetTools that renders pWidgets on a widget that hosts several
# interactive tk widget elements. We define a pWidget to be a tk
# widget element such as a button, entry box, label....

# This funtion initializes a basic class that all the pWidgets
# contain.
# name - a vector of character string(s) for the names of the tk widget
# elements corresponding to the pWidgets to be created. The name is
# required and assumed to be unique and will be used as the identifier
# for the pWidget. The length of name should be one except for select
# boxes and radio buttons where more than one names can be given;
# type - a character string for the type (e. g. button, list, ...) of
# the pWidget. This slot will be populated automatically by the system;
# value - an optional character string for the value associated with
# the pWidget. If the pWidget is an entry box, a list box, or a text
# box, the value will also be displayed inside the tk widget element
# corresponding to the pWidget;
# width - an integer for the width of the tk widget element
# corresponding to the pWidget to be created;
# funs - an optional list of functions that are to be executed when a
# given action is performed on the tk widget element corresponding to
# the pWidget. The name for the element in the list defines the type
# of action. Currently, only sClick(a single click), dClick(a double
# click), and kPress(a key strick) are the valid action types;
# preFun - an optional function that is to be executed to format the
# string that will be used to set the value of the pWidget gets updated;
# postFun - an optional function that is to be executed to format the
# string stored as the value of the pWidget when it is reterived by
# any operation;
# notify - an optional list of functions that will be executed each
# time the value of the pWidget gets updated.
#

setClass("basicPW", representation(wName = "character",
                                   wType = "character",
                                   wValue = "ANY",
                                   wWidth = "numeric",
                                   wHeight = "numeric",
                                   wFuns = "list",
                                   wPreFun = "function",
                                   wPostFun = "function",
                                   wNotify = "list",
                                   wEnv = "environment",
                                   wView = "widgetView"))
## Set the get methods
setGeneric("wName",
           function(object) standardGeneric("wName"))
setMethod("wName", "basicPW",
          function(object) object@wName)


setGeneric("wType",
           function(object) standardGeneric("wType"))
setMethod("wType", "basicPW",
          function(object) object@wType)

setGeneric("wValue",
           function(object) standardGeneric("wValue"))
setMethod("wValue", "basicPW",
          function(object) wPostFun(object)(object@wValue))

setGeneric("wWidth",
           function(object) standardGeneric("wWidth"))
setMethod("wWidth", "basicPW",
          function(object) object@wWidth)

setGeneric("wHeight",
           function(object) standardGeneric("wHeight"))
setMethod("wHeight", "basicPW",
          function(object) object@wHeight)

setGeneric("wFuns",
           function(object) standardGeneric("wFuns"))
setMethod("wFuns", "basicPW",
          function(object) object@wFuns)

setGeneric("wNotify",
           function(object) standardGeneric("wNotify"))
setMethod("wNotify", "basicPW",
          function(object) object@wNotify)

setGeneric("wPreFun",
           function(object) standardGeneric("wPreFun"))
setMethod("wPreFun", "basicPW",
          function(object) object@wPreFun)

setGeneric("wPostFun",
           function(object) standardGeneric("wPostFun"))
setMethod("wPostFun", "basicPW",
          function(object) object@wPostFun)

#setGeneric("wEnv",
#           function(object) standardGeneric("wEnv"))
setMethod("wEnv", "basicPW",
          function(object) object@wEnv)

setGeneric("wView",
               function(object) standardGeneric("wView"))
setMethod("wView", "basicPW",
          function(object) object@wView)

## Define the replace methods
setGeneric("wName<-", function(object, value)
           standardGeneric("wName<-"))
setReplaceMethod("wName", "basicPW", function(object, value){
    object@wName <- value; object})

setGeneric("wType<-", function(object, value)
           standardGeneric("wType<-"))
setReplaceMethod("wType", "basicPW", function(object, value){
    object@wType <- value; object})

setGeneric("wValue<-", function(object, value)
               standardGeneric("wValue<-"))
setReplaceMethod("wValue", "basicPW", function(object, value){
    object@wValue <- wPreFun(object)(value);
    if(!is.null(wView(object))){
        updateDisplay(wView(object), wName(object),
                      wType(object), value)};
    object})

setGeneric("wWidth<-", function(object, value)
           standardGeneric("wWidth<-"))
setReplaceMethod("wWidth", "basicPW", function(object, value){
    object@wWidth <- value; object})

setGeneric("wHeight<-", function(object, value)
           standardGeneric("wHeight<-"))
setReplaceMethod("wHeight", "basicPW", function(object, value){
    object@wHeight <- value; object})

setGeneric("wFuns<-", function(object, value)
               standardGeneric("wFuns<-"))
setReplaceMethod("wFuns", "basicPW", function(object, value){
    object@wFuns <- value; object})

setGeneric("wNotify<-", function(object, value)
           standardGeneric("wNotify<-"))
setReplaceMethod("wNotify", "basicPW", function(object, value){
    object@wNotify <- value; object})

setGeneric("wPreFun<-", function(object, value)
           standardGeneric("wPreFun<-"))
setReplaceMethod("wPreFun", "basicPW", function(object, value){
    object@wPreFun <- value; object})

setGeneric("wPostFun<-", function(object, value)
           standardGeneric("wPostFun<-"))
setReplaceMethod("wPostFun", "basicPW", function(object, value){
    object@wPostFun <- value; object})

setGeneric("wEnv<-", function(object, value)
           standardGeneric("wEnv<-"))
setReplaceMethod("wEnv", "basicPW", function(object, value){
    object@wEnv <- value; object})

setGeneric("wView<-", function(object, value)
           standardGeneric("wView<-"))
setReplaceMethod("wView", "basicPW", function(object, value){
    object@wView <- value; object})


.doWidgets<- function(tkWidget, pWidgets){
    ENV <- parent.frame(1)
    funlist <- list()
    widgetids <- list()
    doOne <- function(pWidget, parent){
        if(any(wType(pWidget) == c("radio", "check"))){
            tempFrame <- tkframe(parent)
            tempVar <- tclVar(match(TRUE, wValue(pWidget)))
            for(i in 1:length(wValue(pWidget))){
                temp <- .getWidget(pWidget, tempFrame, i, tempVar)
                fun <- function() {}
                if(wType(pWidget) == "radio"){
                    body <- list(as.name("{"),
                                 substitute(eval(tkfocus(k), env = ENV),
                                            list(k = temp)),
                                 substitute(eval(updateRadio(theWidget(tkWidget), wName(pWidget),
                                                             names(wValue(pWidget)[z])),
                                                 env = ENV), list(z = i)))
                }else{
                    body <- list(as.name("{"),
                                 substitute(eval(tkfocus(k), env = ENV),
                                            list(k = temp)),
                                 substitute(eval(updateCheck(theWidget(tkWidget), wName(pWidget),
                                                             names(wValue(pWidget)[z])),
                                                 env = ENV), list(z = i)))
                }
                body(fun) <- as.call(body)
                assign(paste("cmd", wValue(pWidget)[i],sep=""), fun)
                tkconfigure(temp, command = get(paste("cmd",
                                  wValue(pWidget)[i],sep="")))
                tkpack(temp, side = "left", padx = 2, pady = 1)
                widgetids[[names(wValue(pWidget)[i])]] <<- temp
            }
            tkpack(tempFrame)
        }else if(any(wType(pWidget) == c("list", "text", "entry"))){
            if(wType(pWidget) == "entry"){
                temp <- .getWidget(pWidget, parent, 1)
                tkpack(temp, side = "left", padx = 2, pady = 1)
            }else{
                tempFrame <- tkframe(parent)
                temp <- .getWidget(pWidget, tempFrame, 1)
                tkpack(tempFrame, side = "left", padx = 2, pady = 1)
            }
            widgetids[[wName(pWidget)]] <<- temp

            if(wType(pWidget) == "list"){
                funlist[[wName(pWidget)]] <- function(){
                    tkfocus(temp)
                    .getViewerCmd(tkWidget, pWidget, temp)
                }
                tkbind(temp, "<B1-ButtonRelease>", funlist[[wName(pWidget)]])
            }else{
                funlist[[wName(pWidget)]] <- function(){
                    .getViewerCmd(tkWidget, pWidget, temp)
                }
                tkbind(temp, "<FocusOut>", funlist[[wName(pWidget)]])
            }
        }else{
            temp <- .getWidget(pWidget, parent, 1)
            tkpack(temp, side = "left", padx = 2, pady = 1)
            widgetids[[wName(pWidget)]] <<- temp
        }
    }


    doRow <- function(aRow){
        if(length(aRow) > 1){
            tempFrame <- tkframe(winid(tkWidget))
            lapply(aRow, doOne, tempFrame)
            tkpack(tempFrame, padx = 5, pady = 5)
        }else{
            tempFrame <- tkframe(winid(tkWidget))
            doOne(aRow[[1]], tempFrame)
            tkpack(tempFrame, padx = 5, pady = 5)
        }
    }

    lapply(pWidgets, doRow)
    return(widgetids)
}

.getWidget <- function(pWidget, parent, index = NULL, var = NULL){
    temp <- NULL
    switch(tolower(wType(pWidget)),
           "entry" = temp <- .renderEntry(pWidget, parent),
           "text" = ,
           "list" = temp <- .renderViewer(pWidget, parent),
           "label" = temp <- .renderLabel(pWidget, parent),
           "radio" = temp <- .renderRadio(pWidget, parent, index, var),
           "button" = temp <- .renderButton(pWidget, parent),
           "check" = temp <- .renderCheck(pWidget, parent, index),
           stop("Invalid pWidget type"))

    return(temp)
}

.renderEntry <- function(pWidget, parent){
    temp <- tkentry(parent, width = wWidth(pWidget), font = "courier 11")
    if(wValue(pWidget) != "" && !is.na(wValue(pWidget)) &&
       !is.null(wValue(pWidget))){
        writeText(temp, wValue(pWidget), FALSE)
    }
    return(temp)
}

.renderViewer <- function(pWidget, parent){
    tempFrame <- tkframe(parent)
    if(wType(pWidget) == "list"){
        toShow <- names(wValue(pWidget))
    }else{
        toShow <- wValue(pWidget)
    }
    temp <- makeViewer(tempFrame, text = toShow,
                       vWidth = wWidth(pWidget), vHeight = wHeight(pWidget),
                       hScroll = TRUE, vScroll = TRUE, what = wType(pWidget))
    if(wType(pWidget) == "list"){
        tkconfigure(temp, selectmode = "extended")
    }
    tkpack(tempFrame)
    return(temp)
}

.renderRadio <- function(pWidget, parent, index, var){
    temp <- tkradiobutton(parent, text = names(wValue(pWidget)[index]),
                          value = index, variable = var)
    return(temp)
}

.renderLabel <-function(pWidget, parent){
    temp <- tklabel(parent, text = wValue(pWidget),
                    width = wWidth(pWidget))
    return(temp)
}

.renderButton <- function(pWidget, parent){
    fun <- list()
    temp <- tkbutton(parent, text = wValue(pWidget),
                     width = wWidth(pWidget))
    fun[[wName(pWidget)]] <- function(){
        tkfocus(temp)
        wFuns(pWidget)[["command"]]()
    }
    tkconfigure(temp, command = fun[[wName(pWidget)]])
    return(temp)
 }

.renderCheck <- function(pWidget, parent, index){
    tempVar <- basename(tempfile("var"))
    temp <- tkcheckbutton(parent, variable = tempVar,
                          text = names(wValue(pWidget)[index]))
    if(wValue(pWidget)[index]){
        tkselect(temp)
    }
    return(temp)
}

.getViewerCmd <- function(widgetView, pWidget, widget){
    if(wType(pWidget) == "list"){
        tempValue <- getListValue(widget)
        updateRadio(theWidget(widgetView), wName(pWidget), tempValue)
    }else if(wType(pWidget) == "text"){
        tempValue <- getTextValue(widget)
        updateText(theWidget(widgetView), wName(pWidget), tempValue)
    }else{
        tempValue <- getEntryValue(widget)
        updateText(theWidget(widgetView), wName(pWidget), tempValue)
    }
}

.renew <- function(widgetView, pWidgets){
    renewOne <- function(pWidget){
        if(wType(pWidget) == "radio"){
            tkselect(widgetids(widgetView)
                         [[names(wValue(pWidget)[wValue(pWidget) == TRUE])]])
        }else if(wType(pWidget) == "check"){
            for(i in names(wValue(pWidget)[wValue(pWidget) == TRUE])){
                tkselect(widgetids(widgetView)[[i]])
            }
            for(i in names(wValue(pWidget)[wValue(pWidget) != TRUE])){
                tkdeselect(widgetids(widgetView)[[i]])
            }
        }else if(wType(pWidget) == "text"){
            writeText(widgetids(widgetView)[[wName(pWidget)]],
                                                     wValue(pWidget))
        }else if(wType(pWidget) == "entry"){
            writeList(widgetids(widgetView)[[wName(pWidget)]],
                                                     wValue(pWidget))
        }else if(wType(pWidget) == "list"){
            writeList(widgetids(widgetView)[[wName(pWidget)]],
                                               names(wValue(pWidget)))
        }
    }
    for(i in pWidgets){
        if(length(i) > 1){
            lapply(i, renewOne)
        }else{
            renewOne(i)
        }
    }
}

\name{basicPW-class}
\docType{class}
\alias{basicPW-class}
\alias{wHeight<-}
\alias{wHeight}
\alias{wNotify<-}
\alias{wNotify}
\alias{wType<-}
\alias{wType}
\alias{wValue<-}
\alias{wValue}
\alias{wPostFun}
\alias{wPostFun<-}
\alias{wPreFun}
\alias{wPreFun<-}
\alias{wView<-}
\alias{wView}
\alias{wWidth<-}
\alias{wWidth}
\alias{wEnv}
\alias{wEnv<-}
\alias{wFuns}
\alias{wName}
\alias{wPreFun}
\alias{wPostFun<-}
\alias{wFuns<-}
\alias{wName<-}
\alias{wHeight<-,basicPW-method}
\alias{wHeight,basicPW-method}
\alias{wNotify<-,basicPW-method}
\alias{wNotify,basicPW-method}
\alias{wType<-,basicPW-method}
\alias{wType,basicPW-method}
\alias{wValue<-,basicPW-method}
\alias{wValue,basicPW-method}
\alias{wPostFun,basicPW-method}
\alias{wPreFun<-,basicPW-method}
\alias{wView<-,basicPW-method}
\alias{wView,basicPW-method}
\alias{wWidth<-,basicPW-method}
\alias{wWidth,basicPW-method}
\alias{wEnv,basicPW-method}
\alias{wFuns,basicPW-method}
\alias{wName,basicPW-method}
\alias{wPreFun,basicPW-method}
\alias{wPostFun<-,basicPW-method}
\alias{wFuns<-,basicPW-method}
\alias{wName<-,basicPW-method}
\alias{wEnv<-,basicPW-method}
\title{Class "basicPW", a basic class for primary widgets}
\description{This class defines the behavior shared by primary widget
  object used to build a GUI type interface}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("basicPW", ...)}.
    Constructors have been defined to create objects of this class for
    specific widgets such as buttons, list boxes, .. 
}
\section{Slots}{
  \describe{
    \item{\code{wName}:}{Object of class \code{"character"} - a string
      for the name of the object}
    \item{\code{wType}:}{Object of class \code{"character"} - a string
      defining the type of the primary widget. (e.g. button)}
    \item{\code{wValue}:}{Object of class \code{"ANY"} - the initial
      value to be associated with the object}
    \item{\code{wWidth}:}{Object of class \code{"numeric"} - an integer
      for the width of the object to be rendered (if applicable)}
    \item{\code{wHeight}:}{Object of class \code{"numeric"} - an integer
      for the height of the object to be rendered (if applicable)}
    \item{\code{wFuns}:}{Object of class \code{"list"} - a list of R
      functions to be executed before the widget is activated}
    \item{\code{wPreFun}:}{Object of class \code{"function"} - a list of
      functions to be executed before the value of the widget to be updated}
    \item{\code{wPostFun}:}{Object of class \code{"function"} - a list of
      functions to be executed before the value of the widget to be retrieved}
    \item{\code{wNotify}:}{Object of class \code{"list"} - a list of
      functions to be executed each time when the value of the widget changes}
    \item{\code{wEnv}:}{Object of class \code{"environment"} - an R
      environment object within which the value of the object is stored}
    \item{\code{wView}:}{Object of class \code{"widgetView"} - a object
      of the class widgetView to which the widget is rendered}
  }
}

\section{Methods}{
  \describe{
    \item{wEnv<-}{\code{signature(object = "basicPW")}: Set the value for
      wEnv slot}
    \item{wEnv}{\code{signature(object = "basicPW")}: Get the value for
      wEnv slot }
    \item{wFuns<-}{\code{signature(object = "basicPW")}: Set the value
      for wFuns slot}
    \item{wFuns}{\code{signature(object = "basicPW")}: Get the value for
      wFuns slot}
    \item{wHeight<-}{\code{signature(object = "basicPW")}: Set the value
      for wHeight slot}
    \item{wHeight}{\code{signature(object = "basicPW")}: Get the value
      for wHeight slot}
    \item{wName<-}{\code{signature(object = "basicPW")}: Set the value
      for wName slot}
    \item{wName}{\code{signature(object = "basicPW")}: Get the value for
      wName slot}
    \item{wNotify<-}{\code{signature(object = "basicPW")}: Set the value
      for wNotify slot}
    \item{wNotify}{\code{signature(object = "basicPW")}: Get the value
      for wNotify slot}
    \item{wPostFun<-}{\code{signature(object = "basicPW")}: Set the value
      for wPostFun slot} 
    \item{wPostFun}{\code{signature(object = "basicPW")}: Get the value
      for wPostFun slot}
    \item{wPreFun<-}{\code{signature(object = "basicPW")}: Set the value
      for wPreFun slot}
    \item{wPreFun}{\code{signature(object = "basicPW")}: Get the value
      for wPreFun slot}
    \item{wType<-}{\code{signature(object = "basicPW")}: Set the value
      for wType slot}
    \item{wType}{\code{signature(object = "basicPW")}: Get the value for
      wType slot}
    \item{wValue<-}{\code{signature(object = "basicPW")}: Set the value
      for wValue slot}
    \item{wValue}{\code{signature(object = "basicPW")}: Get the value for
      wValue slot} 
    \item{wView<-}{\code{signature(object = "basicPW")}: Set the value
      for wView slot }
    \item{view}{\code{signature(object = "basicPW")}: Get the value for
      wView slot }
    \item{wWidth<-}{\code{signature(object = "basicPW")}: Set the value
      for wWidth slot }
    \item{wWidth}{\code{signature(object = "basicPW")}: Get the value for
      wWidth slot}
  }
}
\references{Programming with data }
\author{Jianhua Zhang}

\seealso{\code{\link{widgetView-class}},\code{\link{widget-class}} }

\examples{
# Create an R environment to store the values of primary widgets
PWEnv <- new.env(hash = TRUE, parent = parent.frame(1))

# Create a label
label1 <- label(wName = "label1", wValue = "File Name: ", wEnv = PWEnv)

# Create an entry box with "Feed me using brows" as the default value
entry1 <- entryBox(wName = "entry1", wValue = "Feed me using browse",
                   wEnv = PWEnv)
}
\keyword{classes}

\name{button}
\alias{button}
\alias{entryBox}
\alias{textBox}
\alias{listBox}
\alias{checkButton}
\alias{radioButton}
\alias{label}
\alias{widget}
\alias{widgetView}
\title{Functions to construct objects of primary widgets and render them}
\description{
  All the primary widgets such as button, text box, and so on are
  objects of basicPW class. The functions are constructors of primary
  widgets that are subjects of basicPW class with behaviors specific to
  primary widgets.  
}
\usage{
button(wName, wEnv, wValue = "", wWidth = 12, wHeight = 0, wFuns = list(),
wNotify = list(), wPreFun = function(x) x, wPostFun = function(x) x,
wView = new("widgetView") )
entryBox(wName, wEnv, wValue = "", wWidth = 50, wHeight = 0, wFuns = list(),
wNotify = list(), wPreFun = function (x) x, wPostFun = function(x) x,
wView = new("widgetView"))
textBox(wName, wEnv, wValue = "", wWidth = 25, wHeight = 12, wFuns = list(),
wNotify = list(), wPreFun = function (x) x, wPostFun = function(x) x,
wView = new("widgetView"))
listBox(wName, wEnv, wValue = "", wWidth = 25, wHeight = 10, wFuns = list(),
wNotify = list(), wPreFun = function (x) x, wPostFun = function(x) x,
wView = new("widgetView"))
checkButton(wName, wEnv, wValue, wWidth = 50, wFuns = list(), wNotify =
list(), wPreFun = function (x) x, wPostFun = function(x) x,
wView = new("widgetView"))
radioButton(wName, wEnv, wValue, wWidth = 50, wFuns = list(), wNotify =
list(), wPreFun = function (x) x, wPostFun = function(x) x,
wView = new("widgetView"))
label(wName, wEnv, wValue = "", wWidth = 0, wHeight = 0, wFuns = list(),
wNotify = list(), wPreFun = function (x) x, wPostFun = function(x) x,
wView = new("widgetView"))
widget(wTitle, pWidgets, funs = list(), preFun = function()
print("Hello"), postFun = function() print("Bye"), env, defaultNames =c(
"Finish", "Cancel"))
widgetView(WVTitle, vName, widgetids = list(), theWidget = new("widget"),
winid)
}
\arguments{
  \item{wName}{\code{wName} a character string for the name to be
    associated with a given primary widget}
  \item{vName}{\code{vName} same as wName but for a widget object}
  \item{wEnv}{\code{wEnv} an R environment object within which the
    original values for each primary widget will be stored and updating
    and retrieval of the values will take place}
  \item{env}{\code{env} same as wEnv but for a widget object}
  \item{wValue}{\code{wValue} the initial values to be associated with a
    given primary widget}
  \item{wWidth}{\code{wWidth} an integer for the width of the primary
    widget (if applicable)} 
  \item{wHeight}{\code{wHeight} an integer for the height of the primary
    widget (if applicable)}
  \item{wFuns}{\code{wFuns} a list of R functions that will be
    associated with a primary widget and invoked when an operation
    (e.g. click, get focus, ...) is applied to the primary widget}
  \item{funs}{\code{funs} same as wFuns but for a widget object}
  \item{wNotify}{\code{wNotify} a list of functions defining the actions to
    be performed when the value of the primary widget changes}
  \item{wPreFun}{\code{wPreFun} an R function that should be applied when
    the widget is activated}
  \item{preFun}{\code{preFun} same as wPreFun but for a view}
  \item{wPostFun}{\code{wPostFun} an R function that will be applied when
    the widget is inactivated}
  \item{postFun}{\code{postFun} same as wPostFun but for a view}
  \item{wTitle}{\code{wTitle} a character string for the title to be
    displayed when the widget is rendered}
  \item{pWidgets}{\code{pWidget} a list of primary widgets (e.g. button,
    list box, ...) to be rendered}
  \item{WVTitle}{\code{WVTitle} same as wTitle}
  \item{widgetids}{\code{widgetids} a list of tkwin ids for the primary
    widgets to be rendered}
  \item{theWidget}{\code{theWidget} a \code{\link{widget}} object to
    render the primary widgets}
  \item{wView}{\code{wView} an object of class widgetView}
  \item{winid}{\code{winid} an object of class winid}
  \item{defaultNames}{\code{defaultName} a vector of character string of
    length two for the text to be shown on the two default buttons. The
    first is to end the process and the second to abort the process}
}
\details{
  \code{\link{button}} constructs a button widget object.
  
  \code{\link{button}} constructs an entry box widget object.
  
  \code{\link{textBox}} constructs a text box widget object.
  
  \code{\link{listBox}} constructs a list box widget object. Value for
  a listbox object should be a named vector with names being the content 
  to be shown in the list box and values being TRUE (default value) or
  FALSE.

  \code{\link{checkButton}} constructs a group of check box widget
  objects. Value for check button objects should be a named vector
  with names being the content to be shown in the list box and values
  being TRUE (checked) or FALSE (not checked). 

  \code{\link{radioButton}} constructs a group of radio button widget
  objects. Value for radio button objects should be a named vector
  with names being the content to be shown in the list box and values
  being TRUE (default) or FALSE.

  \code{\link{label}} constructs a text label widget object with the
  value displayed as the text.

  \code{\link{widget}} constructs a widget object to render the primary
  widgets.

  \code{\link{widgetView}} constructs a widgetView object. This class is
  for internal use by class \code{\link{widget-class}}. Users trying to
  create GUI type widget do not need to use this class.
}
\value{
  Each constructor returns a tkwin object for the primary widget object.
}
\references{R tcltk}
\author{Jianhua Zhang}

\seealso{\code{\link{widget-class}}, \code{\link{basicPW-class}}}
\examples{
# Create an R environment to store the values of primary widgets
PWEnv <- new.env(hash = TRUE, parent = parent.frame(1))

# Create a label
label1 <- label(wName = "label1", wValue = "File Name: ", wEnv = PWEnv)

# Create an entry box with "Feed me using brows" as the default value
entry1 <- entryBox(wName = "entry1", wValue = "Feed me using browse",
                   wEnv = PWEnv)

# Create a button that will call the function browse2Entry1 when
# pressed.
browse2Entry1 <- function(){
    tempValue <- tclvalue(tkgetOpenFile())
    temp <- get(wName(entry1), env = PWEnv)
    wValue(temp) <- paste(tempValue, sep = "", collapse = ";")
    assign(wName(entry1), temp, env = PWEnv)
}
button1 <- button(wName = "button1", wValue = "Browse",
                     wFuns = list(command = browse2Entry1), wEnv = PWEnv)

# Create a list box with "Option1", "Option2", and "Option3" as the
# content and "Option1" selected
list1 <- listBox(wName = "list1", wValue = c(Option1 = TRUE, Option2 = FALSE,
                                 Option3 = FALSE), wEnv = PWEnv)

# Create a text box with "Feed me something" displayed
text1 <- textBox(wName = "text1", wValue = "Feed me something",
                 wEnv = PWEnv)

# Create a set of radio buttons with "radio1" as the default
label2 <- label(wName = "label2", wValue = "Select one:  ", wEnv = PWEnv)
radios1 <- radioButton(wName = "radios1", wValue = c(radio1 = TRUE,
                       radio2 = FALSE, radio3 = FALSE), wEnv = PWEnv)

# Create a set of check boxes with "check1" selected and "check2" and
# "check3" not selected
label3 <- label(wName = "label3", wValue = "Select one to many: ",
wEnv = PWEnv)
checks1 <- checkButton(wName = "checks1", wValue = c(check1 = TRUE,
                       check22 = FALSE, check3 = FALSE), wEnv = PWEnv)

# Please not that the name of the primary widget object (e.g. checks1)
# should be the same as the value of the name slot of the object
# (e. g. name = "checks1")

# Render the widgets
pWidgets <- list(topRow = list(label1 = label1, entry1 = entry1,
                 button1 = button1), textRow = list(list1 = list1,
                 text1 = text1), radGroup = list(label2 = label2,
                 radios1 = radios1), chkGroup = list(label3 = label3,
                                     checks1 = checks1))
\dontrun{
## These cannot be run by examples() but should be OK when pasted
## into an interactive R session with the widgetTools package loaded

aWidget <- widget(wTitle = "A test widget", pWidgets, funs = list(),
                 preFun = function() print("Hello"),
                 postFun = function() print("Bye"), env = PWEnv)
} 
}
\keyword{interface}

\name{writeText}
\alias{writeText}
\alias{writeList}
\alias{getListValue}
\alias{getTextValue}
\alias{getEntryValue}

\title{Functions that read from and write to tcltk widgets}
\description{
  These functions provide some of the common read and write operations
  for tcltk widgets
}
\usage{
writeText(widget, value, clear = TRUE)
writeList(widget, value, clear = TRUE)
getListValue(which)
getTextValue(which)
getEntryValue(which)
}

\arguments{
  \item{widget}{\code{widget} a tkwin object for the tcltk widget to be
    read or written to}
  \item{value}{\code{value} the text of numerical value to be written to
    a tcltk widget}
  \item{clear}{\code{clear} a boolean to indicate whether a value will
    append to the existing one (FALSE)}
  \item{which}{\code{which} a tkwin object for the tcltk widget whose
  value will be retrieved}
}
\details{
  \code{\link{writeText}} writes to a given tcltk text box widget.

  \code{\link{writeList}} writes to a given tcltk list or entry box
  widget.

  \code{\link{getListValue}} retrieves the selected value in a tcltk
  list widget.

  \code{\link{getTextValue}} retrieves the value of a text box.

  \code{\link{getEntryValue}} retrieves the value of an entry box.
}
\value{
  \code{\link{getListValue}} returns the selected value in a tcltk
  list widget.

  \code{\link{getTextValue}} returns the value of a text box.

  \code{\link{getEntryValue}} returns the value of an entry box.
}
\references{R tcltk}
\author{Jianhua Zhang}

\seealso{\code{\link{basicPW-class}}, \code{\link{widget-class}}}
\examples{
\dontrun{
    ## These cannot be run by examples() but should be OK when pasted
    ## into an interactive R session with the widgetTools package loaded

    # Create the widgets
    base <- tktoplevel()
    list <- tklistbox(base, width = 20, height = 5)

    entry <- tkentry(base)
    text <- tktext(base, width = 20, height = 5)
    tkpack(list, entry, text)
    # Write and read from the widgets
    writeList(list, c("Option1", "Option2", "Option3"))
    writeList(entry, "An Entry box")
    writeText(text, "A text box")
    # Will be NULL if not selected
    getListValue(list)
    getTextValue(text)
    getEntryValue(entry)
# Destroy toplevel widget
#    tkdestroy(base)
}
}
\keyword{interface}

\name{tooltip}
\alias{tooltip}
\title{A tcltk widget to mimic a tooltip}
\description{
  Current tcltk library does not support tooltip unless an extension is
  included. The function tooltip is implemented as an alternative. 
}
\usage{
tooltip(text, targetWidget, width = 350)
}
\arguments{
  \item{text}{\code{text} a character string for the content of the tooltip}
  \item{targetWidget}{\code{targetWidget} a tkwin object for the target
    tcltk widget to which a tool tip will be associated}
  \item{width}{\code{width} an integer for the width (in pixels) of the
    tooltip} 
}
\details{
  Given a target tcltk widget, a tooltip will be associated with the
  widget. The content of the tooltip will be shown when mouse moves over
  the widget and disappear when mouse moves out of the widget.
}
\value{
  This function returns invisible()
}
\references{tcltk}
\author{Jianhua Zhang}

\seealso{\code{\link{dropdownList}}}
\examples{
\dontrun{
    ## These cannot be run by examples() but should be OK when pasted
    ## into an interactive R session with the widgetTools package loaded
    
    base <- tktoplevel()
    but <- tkbutton(base, text = "Move Mouse Over Me")
    tkpack(but)
    tkbind(but, "<Enter>", expression(tooltip("Move mouse off me", but)))

    # Destroy toplevel widget
    # tkdestroy(base)
}
}
\keyword{misc}

\name{makeViewer}
\alias{makeViewer}
\title{Put a Scrollable List Box into a tkWidget.}
\description{
  This function associates a tk listbox with a scroll bar and then puts
  them into a given tk widget.
}
\usage{
makeViewer(target, vWidth = "", vHeight = "", hScroll = FALSE,
vScroll = TRUE, what = "list", side = "left", text = "")
}

\arguments{
  \item{target}{tk widget that can accommodate a list box.}
  \item{vWidth, vHeight}{integers giving width and height of the listbox.}
  \item{hScroll, vScroll}{logicals indicating whether a horizontal or
    vertical scroll bar should be associated with the list box.}
  \item{what}{A character string indicating the type of the viewer to be
    put on a widget. Valid types include "list" for list box, "canvas",
    and "text" for text box}
  \item{side}{A character string for the geometry management of the
    viewer on the widget. Valid values include "left", "right", "top",
    and "bottom"}
  \item{text}{A character string to be displayed}
}
\details{
  Tk list boxes (or canvas, text box) and scroll bars are separate
  widgets. This function provides a common interface to put them
  together and functionally associated. 
}
\value{
  This function does not return any value.
}
\author{Jianhua (John) Zhang}

\seealso{\code{\link[tcltk:TkWidgets]{tklistbox}} (from the \file{tcltk}
  package). 
}
\examples{
\dontrun{
    ## These cannot be run by examples() but should be OK when pasted
    ## into an interactive R session with the widgetTools package loaded
    
    # Create a top level window and put a list box in it
    base <- tktoplevel()
    listBox <- makeViewer(base)

    # Destroy toplevel widget
    # tkdestroy(base)
 }
}
\keyword{interface}

\name{safeFileOpen}
\alias{safeFileOpen}
\title{A function that checks to see if a connection can be made to a
  given file}
\description{
  This function checks to see if a given file name exists. If so, the
  function returns a connection to the file. Otherwise, it returns
  "fileName doest exist".
}
\usage{
safeFileOpen(fileName)
}

\arguments{
  \item{fileName}{\code{fileName} a character string for the name of a
    file to which a connection is to be oppened}
}
\details{
  When this function is used, users have to make sure to check to see if
  the returnd object inherits object "connection". Otherwise, the file
  doest not exist or a connection has not be made. 
}
\value{
  The function returns a connection object that inherits class
  "connection" if the file exists and is opend. Otherwise, the string
  "fileName doest not exist"
}
\author{Jianhua Zhang}
\note{This function is no placed here to be used by various
  widgets. May be mored to a more suitable place later}

\seealso{\code{\link{file}}}
\examples{
write("A test file", "testFile4safeFileOpen")
tt <- safeFileOpen("testFile4safeFileOpen")
inherits(tt, "connection")
unlink("testFile4safeFileOpen")
tt <- safeFileOpen("testFile4safeFileOpen")
inherits(tt, "connection")
}
\keyword{file}

\name{widget-class}
\docType{class}
\alias{widget-class}
\alias{env<-}
\alias{funs<-}
\alias{funs}
\alias{postFuns<-}
\alias{postFun}
\alias{preFuns<-}
\alias{preFun}
\alias{pWidgets<-}
\alias{pWidgets}
\alias{updateCheck}
\alias{updateList}
\alias{updateRadio}
\alias{updateText}
\alias{wTitle<-}
\alias{wTitle}
\alias{env<-,widget-method}
\alias{funs<-,widget-method}
\alias{funs,widget-method}
\alias{postFuns<-,widget-method}
\alias{postFun,widget-method}
\alias{preFuns<-,widget-method}
\alias{preFun,widget-method}
\alias{wEnv,widget-method}
\alias{pWidgets<-,widget-method}
\alias{pWidgets,widget-method}
\alias{updateCheck,widget-method}
\alias{updateList,widget-method}
\alias{updateRadio,widget-method}
\alias{updateText,widget-method}
\alias{wTitle<-,widget-method}
\alias{wTitle,widget-method}
\title{Class "widget" creates a widget with primary widgets contained in
the list pWidgets rendered}
\description{This class takes a list of primary widgets and then creates a
  "widgetView" object that renders the primary widgets}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("widget", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{wTitle}:}{Object of class \code{"character"} - a
      character string for the title of the widget to be created}
    \item{\code{pWidgets}:}{Object of class \code{"list"} - a list of
      "basicPW" objects representing widget elements to be rendered}
    \item{\code{env}:}{Object of class \code{"environment"} - an R
      environment for the object to work within}
    \item{\code{funs}:}{Object of class \code{"list"} - a list of
      functions that will be associated with buttons on the widget to be
      rendered. The name of the function in the list will be the text
      appears on the button and the function will be executed when the
      button is pressed} 
    \item{\code{preFun}:}{Object of class \code{"function"} - a function
      that will be executed before the widget is constructed}
    \item{\code{postFun}:}{Object of class \code{"function"} - a function
      that will be executed before the widget is destroyed}
  }
}

\section{Methods}{
  \describe{
    \item{env<-}{\code{signature(object = "widget")}: set the value for env}
    \item{wEnv}{\code{signature(object = "widget")}: get the value for env}
    \item{funs<-}{\code{signature(object = "widget")}: set the value for
      funs}
    \item{funs}{\code{signature(object = "widget")}: get the value for funs}
    \item{postFuns<-}{\code{signature(object = "widget")}: set the value
      for postFuns}
    \item{postFun}{\code{signature(object = "widget")}: get the value
      for postFuns}
    \item{preFuns<-}{\code{signature(object = "widget")}: set the value
      for preFun}
    \item{preFun}{\code{signature(object = "widget")}: get the value for
      preFun}
    \item{pWidgets<-}{\code{signature(object = "widget")}: set the value
      for pWidgets}
    \item{pWidgets}{\code{signature(object = "widget")}: get the value
      for pWidgets}
    \item{updateCheck}{\code{signature(object = "widget")}: update the
      value of check buttons of the widget to be rendered}
    \item{updateList}{\code{signature(object = "widget")}: update the
      value of list box/entry of the widget to be rendered}
    \item{updateRadio}{\code{signature(object = "widget")}: update the
      value of radio buttons of the widget to be rendered}
    \item{updateText}{\code{signature(object = "widget")}: update the
      value of text box of the widget to be rendered}
    \item{wTitle<-}{\code{signature(object = "widget")}: set the value
      of wTitle}
    \item{wTitle}{\code{signature(object = "widget")}: get the value of
      wTitle} 
  }
}
\references{Programming with data}
\author{Jianhua Zhang}

\seealso{\code{\link{basicPW-class}}, \code{\link{widgetView-class}} }

\examples{
PWEnv <- new.env(hash = TRUE, parent = parent.frame(1))

label1 <- label(wName = "label1", wValue = "File Name: ", wEnv = PWEnv)
entry1 <- entryBox(wName = "entry1", wValue = "Feed me using browse",
                   wEnv = PWEnv)
browse2Entry1 <- function(){
    tempValue <- fileBrowser()
    temp <- get(wName(entry1), wEnv = PWEnv)
    wValue(temp) <- paste(tempValue, sep = "", collapse = ";")
    assign(wName(entry1), temp, env = PWEnv)
}
button1 <- button(wName = "button1", wValue = "Browse",
                     wFuns = list(command = browse2Entry1), wEnv = PWEnv)
list1 <- listBox(wName = "list1", wValue = c(Option1 = TRUE, Option2 = FALSE,
                                 Option3 = FALSE), wEnv = PWEnv)
text1 <- textBox(wName = "text1", wValue = "Feed me something",
                 wEnv = PWEnv)
label2 <- label(wName = "label2", wValue = "Select one:  ", wEnv = PWEnv)
radios1 <- radioButton(wName = "radios1", wValue = c(radio1 = TRUE,
                       radio2 = FALSE, radio3 = FALSE), wEnv = PWEnv)
label3 <- label(wName = "label3", wValue = "Select one to many: ",
wEnv = PWEnv)
checks1 <- checkButton(wName = "checks1", wValue = c(check1 = TRUE,
                       check22 = FALSE, check3 = FALSE), wEnv = PWEnv)
pWidgets <- list(topRow = list(label1 = label1, entry1 = entry1,
                 button1 = button1), textRow = list(list1 = list1,
                 text1 = text1), radGroup = list(label2 = label2,
                 radios1 = radios1), chkGroup = list(label3 = label3,
                                     checks1 = checks1))

\dontrun{
## These cannot be run by examples() but should be OK when pasted
## into an interactive R session with the widgetTools package loaded

aWidget <- widget(wTitle = "A test widget", pWidgets, funs = list(),
                 preFun = function() print("Hello"),
                 postFun = function() print("Bye"), env = PWEnv)
}
}
\keyword{classes}

\name{widgetView-class}
\docType{class}
\alias{widgetView-class}
\alias{killWin}
\alias{vName<-}
\alias{vName}
\alias{renderWidgets}
\alias{renewView}
\alias{theWidget<-}
\alias{theWidget}
\alias{updateDisplay}
\alias{widgetids<-}
\alias{widgetids}
\alias{winid<-}
\alias{winid}
\alias{winWait}
\alias{WVTitle}
\alias{killWin,widgetView-method}
\alias{vName<-,widgetView-method}
\alias{vName,widgetView-method}
\alias{renderWidgets,widgetView,list-method}
\alias{renewView,widgetView,list-method}
\alias{theWidget<-,widgetView-method}
\alias{theWidget,widgetView-method}
\alias{updateDisplay,widgetView-method}
\alias{widgetids<-,widgetView-method}
\alias{widgetids,widgetView-method}
\alias{winid<-,widgetView-method}
\alias{winid,widgetView-method}
\alias{winWait,widgetView-method}
\alias{WVTitle,widgetView-method}
\title{Class "widgetView", a class for a GUI type widget holding widget
  elements}
\description{"widgetView" renders element widgets}
\section{Objects from the Class}{
  Objects can be created by calls of the form \code{new("widgetView",
    ...)}. This class is for internal use by class
  \code{\link{widget-class}}. Users trying to create GUI type widget do
  not need to use this class.
  
}
\section{Slots}{
  \describe{
    \item{\code{WVTitle}:}{Object of class \code{"character"} - a
      character string that will be displayed as the title of the widget
      to be created}
    \item{\code{vName}:}{Object of class \code{"character"} - a character
      string for the vName of the widget}
    \item{\code{winid}:}{Object of class \code{"tkwin"} - a tkwin object
      for the id of the top window for the widget}
    \item{\code{widgetids}:}{Object of class \code{"list"} - a list of
      tkwin ids for element widgets}
    \item{\code{theWidget}:}{Object of class \code{"widget"} - a widget
      object that creates the widgetView}
  }
}

\section{Methods}{
  \describe{
    \item{killWin}{\code{signature(tkWidget = "widgetView")}: destroys
      the window representing the widgetView}
    \item{vName<-}{\code{signature(object = "widgetView")}: set the value
      for vName}
    \item{vName}{\code{signature(object = "widgetView")}: get the value
      for vName}
    \item{renderWidgets}{\code{signature(widgetView = "widgetView",
	pWidgets = "list")}: takes a list of "basicPW" objects
      (pWidgets) and  renders them accordingly} 
    \item{renewView}{\code{signature(widgetView = "widgetView", pWidgets
	= "list")}: using values contained by the "basicPW" objects of
      pWidgets to update the values of widget elements displayed}
    \item{theWidget<-}{\code{signature(object = "widgetView")}: set the
      value for theWidget}
    \item{theWidget}{\code{signature(object = "widgetView")}: get the
      value for theWidget}
    \item{updateDisplay}{\code{signature(widgetView = "widgetView")}:
      update the value of list box or text box element widgets}
    \item{widgetids<-}{\code{signature(object = "widgetView")}: set the
      value of widgetids}
    \item{widgetids}{\code{signature(object = "widgetView")}: get the
      value of widgetids}
    \item{winid<-}{\code{signature(object = "widgetView")}: set the
      value of winid}
    \item{winid}{\code{signature(object = "widgetView")}: set the value
      of winid}
    \item{winWait}{\code{signature(tkWidget = "widgetView")}: make
      widgetView modal}
    \item{WVTitle}{\code{signature(object = "widgetView")}: get the
      value for WVTitle}
  }
}
\references{Programming with data}
\author{Jianhua Zhang}
\seealso{\code{\link{widget-class}},\code{\link{basicPW-class}} }
\examples{
\dontrun{
        ## These cannot be run by examples() but should be OK when pasted
        ## into an interactive R session with the widgetTools package loaded
        
	widgetView <- widgetView(WVTitle = "demo", vName = "widget1")
}
}
\keyword{classes}

\name{dropdownList}
\alias{dropdownList}
\alias{getListOption}
\title{A widget to mimic a dropdown list}
\description{
  The current tcltk library does not support dropdown lists unless an
  extension is included. The function dropdownList provide an alternative.
}
\usage{
dropdownList(base, options, textvariable, width = 10, default, editable
= FALSE)
getListOption(targetWidget, options, height, vScroll = FALSE)
}
\arguments{
  \item{base}{\code{base} a tkwin object that is the parent frame of the
    dropdown list to be created}
  \item{options}{\code{options} a vector of character strings for the
    content of the dropdown list}
  \item{textvariable}{\code{textvariable} a tclVar object to be
    associated with the selected item of the dropdown list}
  \item{width}{\code{width} an integer for the width in number of
    characters of the selection containing part of the dropdown list}
  \item{default}{\code{default} a character string for the default
    selection that is going to be shown in the selection containing
    window of the dropdown list}
  \item{targetWidget}{\code{targetWidget} a tkwin object for an entry
    box to which a button will be associated to make the look of a
    dropdown list}
  \item{editable}{\code{editable} a boolean indicating whether the
    dropdown list will be editable or not}
  \item{height}{\code{height} an integer for the height of the dropdown
    list box. If missing, height will be assigned the length of the
    options to be shown in the list box}
  \item{vScroll}{\code{vScroll} a boolean indicating whether a vertical
    scroll bar will be associated with the dropdown list box}
}
\details{
  \code{base} can be a top window or a frame.

  The widget returns a frame that contains a dropdown list. The frame
  need to be placed using any of the layout methods of tcltk. The value
  of the selection will be accessed through the tclVar object passed to
  the function.

  getListOptions is called by dropdown list to get the selected item
}
\value{
  dropdownList returns a tkwin object for the frame that contains a
  dropdown list

  getListOptions returns a character string for the selected item
}
\references{tcltk}
\author{Jianhua Zhang}

\seealso{\code{\link{tooltip}}}
\examples{
\dontrun{
    ## These cannot be run by examples() but should be OK when pasted
    ## into an interactive R session with the widgetTools package loaded
    
    base <- tktoplevel()
    selection <- tclVar()
    dropdownList(base, c("Option 1", "Option 2", "Option 3"),
          selection, 15, "Option 2")
    tclvalue(selection)
    # Destroy toplevel widget
    # tkdestroy(base)
}
}
\keyword{misc}

\name{oneVScrList}
\alias{oneVScrList}
\title{A function that creates a groups of list boxes sharing a single
  vertical scroll bar}
\description{
  This function creates a group of list boxes what share a common
  vertical scroll bar. Values in all the list boxes scroll up or down
  when the scroll bar is dragged
}
\usage{
oneVScrList(base, data)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{base}{\code{base} a tkwin object that will be the container of
    the list boxes to be created}
  \item{data}{\code{data} a matrix with data to be put in the list boxes} 
}
\details{
  The matrix should have names for its columns. The names of the list
  boxes to be created will be the same as the corresponding columns of
  the matrix.

  Data in the list boxes can be sorted based on values in any of the
  list boxes.
}
\value{
  This function returns a list containing the tkwin objects of the list
  boxes created.
}
\references{tcltk}
\author{Jianhua Zhang}

\seealso{\code{\link{dropdownList}}, \code{\link{tooltip}}}
\examples{
    \dontrun{
        ## These cannot be run by examples() but should be OK when pasted
        ## into an interactive R session with the widgetTools package loaded
        
        testData <- matrix(c(1:50, 100:51), ncol = 2)
        colnames(testData) <- c("Column 1", "Column 2")
        base <- tktoplevel()
        tt <- oneVScrList(base, testData)

        # Destroy toplevel widget
        # tkdestroy(base)
    }
}
\keyword{interface}
